/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/
package jp.co.ntt.lms.installer.lms;

import java.io.File;
import java.util.logging.Logger;

import jp.co.ntt.lms.installer.core.InstallerAction;
import jp.co.ntt.lms.installer.core.InstallerActionValue;
import jp.co.ntt.lms.installer.core.InstallerException;
import jp.co.ntt.lms.installer.core.InstallerValues;
import jp.co.ntt.lms.installer.core.util.InstallerCheckUtil;
import jp.co.ntt.lms.installer.core.util.InstallerUiUtil;
import jp.co.ntt.lms.installer.core.util.InstallerXmlUtil;
import jp.co.ntt.lms.installer.util.LoggerUtil;
import jp.co.ntt.lms.installer.util.XmlUtil;

import org.w3c.dom.Document;

/**
 * フレームワーク画面表示設定について入力するアクション・クラス。
 * @author T.Nishiki
 */
public class ScreenDefineInputAction implements InstallerAction {
	/**
	 * ログ出力オブジェクト。
	 */
	private static Logger _logger;

	/**
	 * スタティック・イニシャライザ。
	 */
	static {
		_logger = LoggerUtil.getLogger(ScreenDefineInputAction.class);
	}

	/**
	 * アクションをスキップするか判定します。<br>
	 * スキップしないのでfalseを戻します。<br>
	 *
	 * @param values インストーラ共通データ・オブジェクト。
	 * @return falseを戻します。
	 */
	public boolean isSkipped(InstallerValues values) {
		return false;
	}

	/**
	 * フレームワーク画面表示設定について入力・確認を求めます。<br>
	 *
	 * @param values インストーラ共通データ・オブジェクト。
	 * @return ScreenDefineInputValueを戻します。
	 * @throws InstallerException 実行中に例外が発生した場合。
	 * @see ScreenDefineInputValue
	 */
	public InstallerActionValue action(InstallerValues values)
		throws InstallerException {

		LoggerUtil.methodHead(_logger, "action(InstallerValues)");

		// 今回入力データ
		ScreenDefineInputValue inputValue = null;
		try {
			// 既存入力データ（デフォルトデータとして使用）
			ScreenDefineInputValue defaultValue = getDefaultValue(values);
			// タイトル表示
			InstallerUiUtil.outputMessageAsTitle(
				values, "ScreenDefineInputAction.welcome");

			while (true) {
				// 入力実行
				inputValue = readInputValue(values, defaultValue);
				// 入力確認
				if (confirmInputValue(values, inputValue) == true) {
					// 入力確認が済んだ場合、指定されたディレクトリを
					// 作成対象として登録する。
					File csvOutput = new File(inputValue.getCsvOutputPath());
					values.addMadeDirectory(csvOutput);
					break;
				}
			}
		}
		catch (InstallerException e) {
			throw e;
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}

		LoggerUtil.methodTail(_logger, "action(InstallerValues)", inputValue);
		return inputValue;
	}

	/**
	 * フレームワーク画面設定ファイルの書換項目について入力を求めます。<br>
	 *
	 * @param values インストーラ共通データ・オブジェクト。
	 * @param defaultValue デフォルト値。
	 * @return 入力された内容をScreenDefineInputValueとして戻します。
	 * @throws InstallerException 実行中に例外が発生した場合。
	 */
	private ScreenDefineInputValue readInputValue(
			InstallerValues values, ScreenDefineInputValue defaultValue)
			throws InstallerException {
		LoggerUtil.methodHead(_logger,
			"readInputValue(InstallerValues)");

		ScreenDefineInputValue inputValue = null;
		try {
			inputValue = new ScreenDefineInputValue();
			// =================================================================
			// CSV出力ディレクトリ
			String csvOutputPath = null;
			while (true) {
				csvOutputPath = InstallerUiUtil.askUserInput(values,
						"ScreenDefineInputAction.prompt.csvOutputPath",
						defaultValue.getCsvOutputPath());
				// 未入力
				if (InstallerCheckUtil.isEmptyViolation(csvOutputPath, values,
						"ScreenDefineInputAction.error.csvOutputPath.empty")) {
					continue;
				}
				// ファイル
				if (InstallerCheckUtil.isFilePath(csvOutputPath, values,
						"ScreenDefineInputAction.error.csvOutputPath.file")) {
					continue;
				}
				break;
			}
			inputValue.setCsvOutputPath(csvOutputPath);
		}
		catch (InstallerException e) {
			throw e;
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}

		LoggerUtil.methodTail(_logger,
			"readInputValue(InstallerValues)", inputValue);
		return inputValue;
	}

	/**
	 * 入力した内容を表示し、ユーザに確認を求めます。<br>
	 * @param values インストーラ共通データ・オブジェクト。
	 * @param inputValue 入力された内容
	 * @return 入力された内容にユーザ確認がとれた場合true、
	 *          とれなかった場合falseを戻します。
	 * @throws InstallerException 処理中にエラーが発生した場合。
	 */
	private boolean confirmInputValue(
			InstallerValues values, ScreenDefineInputValue inputValue)
			throws InstallerException {

		// メソッド開始ログ
		LoggerUtil.methodHead(_logger,
			"confirmInputValue(InstallerValues, ScreenDefineInputValue)");
		boolean confirm = false;
		try {
			InstallerUiUtil.outputConfirmTitle(values,
				"ScreenDefineInputAction.confirm.title");
			// =================================================================
			// 入力内容の表示
			// =================================================================
			// CSV出力ディレクトリ
			InstallerUiUtil.outputConfirm(values,
				"ScreenDefineInputAction.confirm.csvOutputPath",
				inputValue.getCsvOutputPath());
			// =================================================================
			// ユーザ確認
			confirm = InstallerUiUtil.askUserConfirm(
				values, "ScreenDefineInputAction.confirm" );
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}
		// メソッド終了ログ
		LoggerUtil.methodTail(_logger,
			"confirmInputValue(InstallerValues, ScreenDefineInputValue)",
			confirm);
		return confirm;
	}

	/**
	 * 既存のデータから、入力項目のデフォルト値を取得します。<br>
	 * @param values インストーラ共通データ・オブジェクト。
	 * @return デフォルト値をManagerInputValueの形で戻します。
	 * @throws InstallerException 実行中に例外が発生した場合。
	 */
	private ScreenDefineInputValue getDefaultValue(InstallerValues values)
			throws InstallerException {
		// メソッド開始ログ
		LoggerUtil.methodHead(_logger,
			"getDefaultValue(InstallerValues)");

		ScreenDefineInputValue defaultValue = null;
		try {
			defaultValue = new ScreenDefineInputValue();
			////////////////////////////////////////////////////////////////////
			// プロパティの取得
			// =================================================================
			// 既存の内容
			File existFile = values.getFileOnSystem(
					defaultValue.getTargetFileKey());
			Document existDoc
				= XmlUtil.convertXmlFileToDocument(existFile);
			// =================================================================
			// リソース（原本）の内容
			Document resourceDoc
				= InstallerXmlUtil.load(
					values, defaultValue.getTargetFileKey());
			////////////////////////////////////////////////////////////////////
			// デフォルト値の設定
			defaultValue = new ScreenDefineInputValue();
			// =================================================================
			// CSV出力ディレクトリ
			String csvOutputPath = InstallerXmlUtil.determineInitialNodeValue(
								existDoc, resourceDoc,
								ScreenDefineInputValue.XPATH_CSV_OUTPUT_PATH);
			defaultValue.setCsvOutputPath(csvOutputPath);
		}
		catch (InstallerException e) {
			throw e;
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}
		// メソッド終了ログ
		LoggerUtil.methodTail(_logger,
			"getDefaultValue(InstallerValues)", defaultValue);
		return defaultValue;
	}
}
